package net.fukure.flazrdumper;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;

import javax.activation.FileTypeMap;

import net.fukure.flazrdumper.io.ChunkedInputStream;

public class Http {
	
	private final String docRoot = "public_html";
	
	private InputStream is;
	private OutputStream os;
	
	public String header;
	public String path;
	
	public Http(Socket socket) throws IOException {
		is = socket.getInputStream();
		os = socket.getOutputStream();
	}
	
	public Http(InputStream is, OutputStream os){
		this.is = is;
		this.os = os;
	}
	
	public void readHeader(InputStream is) throws IOException{
        ChunkedInputStream cin = new ChunkedInputStream(is);
        StringBuffer sb = new StringBuffer();
		String line = "";
        while((line = cin.readline()) != null){
        	if(line.length()==0) break;
    		if(sb.length()>64*1024) throw new IOException("64k overflow");
        	sb.append(line).append("\r\n");
        }
        header =  sb.toString();

		try{
			path = header.split(" ", 3)[1];
			path = docRoot+path;
		}catch(Exception e){
			path = docRoot;
		}
		
	}
	
	public void fileResponse(){
		File file = new File(path);
		File public_html = new File(docRoot);
        try {
			if(file.isFile() && file.getAbsolutePath().startsWith(public_html.getAbsolutePath())){
				byte[] data = readFIle();
				header(path, data);
				body(path, data);
			}else{
				header404();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	private void header404() throws Exception{
		StringBuffer sb = new StringBuffer();
		sb.append("HTTP/1.0 404 Not Found\r\n");
		sb.append("Content-Type: text/html\r\n");
		sb.append("Content-Length: 0\r\n");
		sb.append("Connection: Close\r\n\r\n");
		os.write(sb.toString().getBytes());
		os.flush();
	}
	private void body(String path, byte[] data) throws Exception{
		os.write(data);
		os.flush();
	}
	private void header(String path, byte[] data) throws Exception{
		
        String mimetype = Mime.getContentType(path);
		
		StringBuffer sb = new StringBuffer();
		sb.append("HTTP/1.0 200 OK\r\n");
		sb.append("Content-Type: ").append(mimetype).append("\r\n");
		sb.append("Content-Length: ").append(data.length).append("\r\n");
		sb.append("Connection: Close\r\n\r\n");
		
		os.write(sb.toString().getBytes());
		os.flush();
	}
	private byte[] readFIle() throws Exception{
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		FileInputStream input=new FileInputStream(path);
		byte buf[]=new byte[8192];
		int len;
		while((len=input.read(buf))!=-1){
		   baos.write(buf,0,len);
		}
		input.close();
		return baos.toByteArray();
	}
}
